# Kubernetes basic auth secret

Allows setting up a secret mapping users to hashed passwords.
The secret can be used with Ingresses for basic auth.
The passwords are hashed using `bcrypt`.

<!-- BEGIN_TF_DOCS -->
## Requirements

| Name | Version |
|------|---------|
| <a name="requirement_terraform"></a> [terraform](#requirement\_terraform) | >= 1.0 |

## Providers

| Name | Version |
|------|---------|
| <a name="provider_kubernetes"></a> [kubernetes](#provider\_kubernetes) | n/a |
| <a name="provider_random"></a> [random](#provider\_random) | n/a |

## Modules

No modules.

## Resources

| Name | Type |
|------|------|
| [kubernetes_secret.users](https://registry.terraform.io/providers/hashicorp/kubernetes/latest/docs/resources/secret) | resource |
| [random_password.default-passwords](https://registry.terraform.io/providers/hashicorp/random/latest/docs/resources/password) | resource |
| [random_string.secret_name](https://registry.terraform.io/providers/hashicorp/random/latest/docs/resources/string) | resource |

## Inputs

| Name | Description | Type | Default | Required |
|------|-------------|------|---------|:--------:|
| <a name="input_namespace"></a> [namespace](#input\_namespace) | Kubernetes namespace in which the secret should be created. | `string` | n/a | yes |
| <a name="input_secret_name"></a> [secret\_name](#input\_secret\_name) | Name of the secret that will contain the credentials. | `string` | `null` | no |
| <a name="input_users"></a> [users](#input\_users) | Mapping of users and their passwords. A random password can be generated by using the `true` value instead. | `map(any)` | n/a | yes |

## Outputs

| Name | Description |
|------|-------------|
| <a name="output_haproxy-annotations"></a> [haproxy-annotations](#output\_haproxy-annotations) | Annotations for the HAProxy Ingress Controller that can be used on an Ingress to enable basic auth. |
| <a name="output_secret-uri"></a> [secret-uri](#output\_secret-uri) | Resource identifier for the resulting Kubernetes Secret. |
| <a name="output_users-with-passwords"></a> [users-with-passwords](#output\_users-with-passwords) | Mapping of users with all passwords, whether they were generated or not. |
<!-- END_TF_DOCS -->
